/*
   3D Invaders

   game.h

   (c)2002 Paul Boese
*/

#ifndef __GAME_H
#define __GAME_H

#include "common.h"

#define IROWS 5
#define ICOLS 9
#define BARRIERS 9

enum { BOMB_NOT=0, CAN_BOMB };

typedef struct {
	int active;
	point_t pos;
	int row;
	int col;
	int bomber;
} horde_t;

typedef struct {
	int active;
	point_t pos;
} block_t;

enum { GDEMO, GSTART, GPAUSE, GRESUME, GQUIT };

class Game;

class Game {
	private:
		int mode;
		static horde_t horde[][ICOLS];
		static block_t block[BARRIERS];
		static int move;
		static int xx;
		static int yy;

		int score;
		int hi_score;

		int level;
		int shots;

		int ticks;
		static int refcnt;

		int hit(point_t *v1, point_t *v2, float size);
		void promote_bomber(int row, int col);

	public:
		Game();

		void Demo();
		void Start();
		void Pause();
		void Resume();
		void Quit();
		
		void doInitLevel(Invader ** invaders, Barrier ** barriers, Player * player);

		void doInvaders(Invader ** invaders, Shots ** shots, Bombs ** bombs);

		void doBarrier(Barrier ** barriers, Invader ** invaders,
				Shots ** shots, Bombs ** bombs);
		
		void doPlayer(Player * player, Invader ** invaders, Bombs ** bombs);
		
		int Score() {
			return score;
		}
		
		int HiScore() {
			return hi_score;
		}
};

#endif /* __GAME_H */
