/* 
   3D Invaders 

   snd.cpp
   
   (c)2002 Paul Boese
*/

#include "common.h"
#include <dc/sound/sfxmgr.h>
#include <oggvorbis/sndoggvorbis.h>

int snd_init() {
	// This intializes all required sound functions including
	// the sfx stuff for loading WAV files.
	sndoggvorbis_init();

	// load up all of our sound effects
	sfx_shot_click = snd_sfx_load("/rd/click.wav");
	sfx_shot_fired = snd_sfx_load("/rd/shot.wav");
	sfx_bomb_drop = snd_sfx_load("/rd/shot.wav");
	sfx_invader_hit = snd_sfx_load("/rd/boom.wav");
	sfx_player_hit = snd_sfx_load("/rd/boom.wav");
	sfx_barrier_hit = snd_sfx_load("/rd/boink.wav");
	return 0;
}

void snd_shutdown() {
	snd_sfx_unload_all();
	sndoggvorbis_stop();
}

void snd_test(char *fn) {
	sndoggvorbis_start(fn, 0);
}

void snd_volume(int vol) {
	sndoggvorbis_volume(vol);
}
